/******************************************************************************
 * Copyright(c) 2008 - 2010 Realtek Corporation. All rights reserved.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110, USA
 *
 * The full GNU General Public License is included in this distribution in the
 * file called LICENSE.
 *
 * Contact Information:
 * Jerry chuang <wlanfae@realtek.com>
******************************************************************************/

#ifdef LED

#ifndef R8185_LED_H
#define R8185_LED_H

#include <linux/types.h>
#include <linux/timer.h>


typedef	enum _LED_STATE_8185{
	LED_UNKNOWN = 0,
	LED_ON = 1,
	LED_OFF = 2,
	LED_BLINK_NORMAL = 3,
	LED_BLINK_SLOWLY = 4,
	LED_POWER_ON_BLINK = 5,
	LED_SCAN_BLINK = 6, 
	LED_NO_LINK_BLINK = 7, 
	LED_BLINK_CM3 = 8, 
}LED_STATE_8185;

typedef enum _LED_PIN_8185{
	LED_PIN_LED0,
}LED_PIN_8185;

typedef struct _LED_8185{
	struct net_device*	pAdapter;

	LED_PIN_8185		LedPin;	

	LED_STATE_8185	CurrLedState; 
	bool				bLedOn; 

	bool				bLedBlinkInProgress; 
	u32				BlinkTimes; 
	LED_STATE_8185	BlinkingLedState; 

	struct timer_list	BlinkTimer; 
} LED_8185, *PLED_8185;



#if 0 
typedef	enum _LED_STRATEGY_8185{
	SW_LED_MODE0, 
	SW_LED_MODE1, 
	HW_LED, 
}LED_STRATEGY_8185, *PLED_STRATEGY_8185;
#endif

typedef	enum _LED_CTL_MODE{
	LED_CTL_POWER_ON = 1,
	LED_CTL_LINK = 2,
	LED_CTL_NO_LINK = 3,
	LED_CTL_TX = 4,
	LED_CTL_RX = 5,
	LED_CTL_SITE_SURVEY = 6,
	LED_CTL_POWER_OFF = 7
}LED_CTL_MODE;

void InitSwLeds(struct net_device *dev);
void DeInitSwLeds(struct net_device *dev);
void LedControl8185(struct net_device *dev, LED_CTL_MODE LedAction);

#ifdef NDIS50_MINIPORT
void LedBlinkTimerStallCheck(struct net_device *dev);
void DoLedTimerStallCheck(PLED_8185 pLed	);
#endif

#endif
#endif

