/******************************************************************************
 * Copyright(c) 2008 - 2010 Realtek Corporation. All rights reserved.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110, USA
 *
 * The full GNU General Public License is included in this distribution in the
 * file called LICENSE.
 *
 * Contact Information:
 * Jerry chuang <wlanfae@realtek.com>
******************************************************************************/

#include <linux/spinlock.h>
#include "r8180_hw.h"
#include "r8180.h"
#include "r8180_sa2400.h"  
#include "r8180_max2820.h" 
#include "r8180_gct.h"     
#include "r8180_rtl8225.h" 
#include "r8180_rtl8255.h" 
#include "r8180_93cx6.h"   
#include "r8180_wx.h"

#ifdef CONFIG_RTL8180_PM
#include "r8180_pm.h"
#endif

#ifdef ENABLE_DOT11D
#include "../ieee80211/dot11d.h"
#endif

#include "r8185_led.h"

#ifdef CONFIG_RTL8185B


#define TC_3W_POLL_MAX_TRY_CNT 5
#ifdef CONFIG_RTL818X_S
static u8 MAC_REG_TABLE[][2]={
                        {0x08, 0xae}, {0x0a, 0x72}, {0x5b, 0x42},
                        {0x84, 0x88}, {0x85, 0x24}, {0x88, 0x54}, {0x8b, 0xb8}, {0x8c, 0x03},
                        {0x8d, 0x40}, {0x8e, 0x00}, {0x8f, 0x00}, {0x5b, 0x18}, {0x91, 0x03},
                        {0x94, 0x0F}, {0x95, 0x32},
                        {0x96, 0x00}, {0x97, 0x07}, {0xb4, 0x22}, {0xdb, 0x00},
                        {0xf0, 0x32}, {0xf1, 0x32}, {0xf2, 0x00}, {0xf3, 0x00}, {0xf4, 0x32},
                        {0xf5, 0x43}, {0xf6, 0x00}, {0xf7, 0x00}, {0xf8, 0x46}, {0xf9, 0xa4},
                        {0xfa, 0x00}, {0xfb, 0x00}, {0xfc, 0x96}, {0xfd, 0xa4}, {0xfe, 0x00},
                        {0xff, 0x00},

                        {0x5e, 0x01},
                        {0x58, 0x00}, {0x59, 0x00}, {0x5a, 0x04}, {0x5b, 0x00}, {0x60, 0x24},
                        {0x61, 0x97}, {0x62, 0xF0}, {0x63, 0x09}, {0x80, 0x0F}, {0x81, 0xFF},
                        {0x82, 0xFF}, {0x83, 0x03},
                        {0xC4, 0x22}, {0xC5, 0x22}, {0xC6, 0x22}, {0xC7, 0x22}, {0xC8, 0x22}, 
			{0xC9, 0x22}, {0xCA, 0x22}, {0xCB, 0x22}, {0xCC, 0x22}, {0xCD, 0x22},
                        {0xe2, 0x00},


                        {0x5e, 0x02},
                        {0x0c, 0x04}, {0x4c, 0x30}, {0x4d, 0x08}, {0x50, 0x05}, {0x51, 0xf5},
                        {0x52, 0x04}, {0x53, 0xa0}, {0x54, 0xff}, {0x55, 0xff}, {0x56, 0xff},
                        {0x57, 0xff}, {0x58, 0x08}, {0x59, 0x08}, {0x5a, 0x08}, {0x5b, 0x08},
                        {0x60, 0x08}, {0x61, 0x08}, {0x62, 0x08}, {0x63, 0x08}, {0x64, 0x2f},
                        {0x8c, 0x3f}, {0x8d, 0x3f}, {0x8e, 0x3f},
                        {0x8f, 0x3f}, {0xc4, 0xff}, {0xc5, 0xff}, {0xc6, 0xff}, {0xc7, 0xff},
                        {0xc8, 0x00}, {0xc9, 0x00}, {0xca, 0x80}, {0xcb, 0x00},

                        {0x5e, 0x00},{0x9f, 0x03}
                };


static u8  ZEBRA_AGC[]={
			0,
			0x7E,0x7E,0x7E,0x7E,0x7D,0x7C,0x7B,0x7A,0x79,0x78,0x77,0x76,0x75,0x74,0x73,0x72,
			0x71,0x70,0x6F,0x6E,0x6D,0x6C,0x6B,0x6A,0x69,0x68,0x67,0x66,0x65,0x64,0x63,0x62,
			0x48,0x47,0x46,0x45,0x44,0x29,0x28,0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x08,0x07,
			0x06,0x05,0x04,0x03,0x02,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
			0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x10,0x11,0x12,0x13,0x15,0x16,
			0x17,0x17,0x18,0x18,0x19,0x1a,0x1a,0x1b,0x1b,0x1c,0x1c,0x1d,0x1d,0x1d,0x1e,0x1e,
			0x1f,0x1f,0x1f,0x20,0x20,0x20,0x20,0x21,0x21,0x21,0x22,0x22,0x22,0x23,0x23,0x24,
			0x24,0x25,0x25,0x25,0x26,0x26,0x27,0x27,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F,0x2F
			};
		
static u32 ZEBRA_RF_RX_GAIN_TABLE[]={	
			0x0096,0x0076,0x0056,0x0036,0x0016,0x01f6,0x01d6,0x01b6,
			0x0196,0x0176,0x00F7,0x00D7,0x00B7,0x0097,0x0077,0x0057,
			0x0037,0x00FB,0x00DB,0x00BB,0x00FF,0x00E3,0x00C3,0x00A3,
			0x0083,0x0063,0x0043,0x0023,0x0003,0x01E3,0x01C3,0x01A3,
			0x0183,0x0163,0x0143,0x0123,0x0103
	};

static u8 OFDM_CONFIG[]={
					
			0x10, 0x0F, 0x0A, 0x0C, 0x14, 0xFA, 0xFF, 0x50, 
			0x00, 0x50, 0x00, 0x00, 0x00, 0x5C, 0x00, 0x00,
			0x40, 0x00, 0x40, 0x00, 0x00, 0x00, 0xA8, 0x26, 
			0x32, 0x33, 0x06, 0xA5, 0x6F, 0x55, 0xC8, 0xBB, 
			0x0A, 0xE1, 0x2C, 0x4A, 0x86, 0x83, 0x34, 0x00, 
			0x4F, 0x24, 0x6F, 0xC2, 0x03, 0x40, 0x80, 0x00, 
			0xC0, 0xC1, 0x58, 0xF1, 0x00, 0xC4, 0x90, 0x3e, 
			0xD8, 0x3C, 0x7B, 0x10, 0x10
		};
#else
 static u8 MAC_REG_TABLE[][2]={ 
			{0xf0, 0x32}, {0xf1, 0x32}, {0xf2, 0x00}, {0xf3, 0x00}, {0xf4, 0x32}, 
			{0xf5, 0x43}, {0xf6, 0x00}, {0xf7, 0x00}, {0xf8, 0x46}, {0xf9, 0xa4}, 
			{0xfa, 0x00}, {0xfb, 0x00}, {0xfc, 0x96}, {0xfd, 0xa4}, {0xfe, 0x00}, 
			{0xff, 0x00}, 

			{0x5e, 0x01}, 
			{0x58, 0x4b}, {0x59, 0x00}, {0x5a, 0x4b}, {0x5b, 0x00}, {0x60, 0x4b}, 
			{0x61, 0x09}, {0x62, 0x4b}, {0x63, 0x09}, {0xce, 0x0f}, {0xcf, 0x00}, 
			{0xe0, 0xff}, {0xe1, 0x0f}, {0xe2, 0x00}, {0xf0, 0x4e}, {0xf1, 0x01}, 
			{0xf2, 0x02}, {0xf3, 0x03}, {0xf4, 0x04}, {0xf5, 0x05}, {0xf6, 0x06}, 
			{0xf7, 0x07}, {0xf8, 0x08}, 


			{0x5e, 0x02},
			{0x0c, 0x04}, {0x21, 0x61}, {0x22, 0x68}, {0x23, 0x6f}, {0x24, 0x76}, 
			{0x25, 0x7d}, {0x26, 0x84}, {0x27, 0x8d}, {0x4d, 0x08}, {0x4e, 0x00},
			{0x50, 0x05}, {0x51, 0xf5}, {0x52, 0x04}, {0x53, 0xa0}, {0x54, 0x1f}, 
			{0x55, 0x23}, {0x56, 0x45}, {0x57, 0x67}, {0x58, 0x08}, {0x59, 0x08}, 
			{0x5a, 0x08}, {0x5b, 0x08}, {0x60, 0x08}, {0x61, 0x08}, {0x62, 0x08}, 
			{0x63, 0x08}, {0x64, 0xcf}, {0x72, 0x56}, {0x73, 0x9a},

			{0x5e, 0x00},
			{0x34, 0xff}, {0x35, 0x0f}, {0x5b, 0x40}, {0x84, 0x88}, {0x85, 0x24}, 
			{0x88, 0x54}, {0x8b, 0xb8}, {0x8c, 0x07}, {0x8d, 0x00}, {0x94, 0x1b}, 
			{0x95, 0x12}, {0x96, 0x00}, {0x97, 0x06}, {0x9d, 0x1a}, {0x9f, 0x10}, 
			{0xb4, 0x22}, {0xbe, 0x80}, {0xdb, 0x00}, {0xee, 0x00}, {0x5b, 0x42},
			{0x91, 0x03},

			{0x5e, 0x02},
			{0x4c, 0x03}, 

			{0x5e, 0x00},

			{0x5e, 0x03},
			{0x9f, 0x00}, 

			{0x5e, 0x00},
			{0x8c, 0x01}, {0x8d, 0x10},{0x8e, 0x08}, {0x8f, 0x00}
		};


static u8  ZEBRA_AGC[]={
	0,
	0x5e,0x5e,0x5e,0x5e,0x5d,0x5b,0x59,0x57,0x55,0x53,0x51,0x4f,0x4d,0x4b,0x49,0x47,
	0x45,0x43,0x41,0x3f,0x3d,0x3b,0x39,0x37,0x35,0x33,0x31,0x2f,0x2d,0x2b,0x29,0x27,
	0x25,0x23,0x21,0x1f,0x1d,0x1b,0x19,0x17,0x15,0x13,0x11,0x0f,0x0d,0x0b,0x09,0x07,
	0x05,0x03,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
	0x19,0x19,0x19,0x019,0x19,0x19,0x19,0x19,0x19,0x19,0x1e,0x1f,0x20,0x21,0x21,0x22,
	0x23,0x24,0x24,0x25,0x25,0x26,0x26,0x27,0x27,0x28,0x28,0x28,0x29,0x2a,0x2a,0x2b,
	0x2b,0x2b,0x2c,0x2c,0x2c,0x2d,0x2d,0x2d,0x2e,0x2e,0x2f,0x30,0x31,0x31,0x31,0x31,
	0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31,0x31
	};

static u32 ZEBRA_RF_RX_GAIN_TABLE[]={	
	0,
	0x0400,0x0401,0x0402,0x0403,0x0404,0x0405,0x0408,0x0409,
	0x040a,0x040b,0x0502,0x0503,0x0504,0x0505,0x0540,0x0541,
	0x0542,0x0543,0x0544,0x0545,0x0580,0x0581,0x0582,0x0583,
	0x0584,0x0585,0x0588,0x0589,0x058a,0x058b,0x0643,0x0644,
	0x0645,0x0680,0x0681,0x0682,0x0683,0x0684,0x0685,0x0688,
	0x0689,0x068a,0x068b,0x068c,0x0742,0x0743,0x0744,0x0745,
	0x0780,0x0781,0x0782,0x0783,0x0784,0x0785,0x0788,0x0789,
	0x078a,0x078b,0x078c,0x078d,0x0790,0x0791,0x0792,0x0793,
	0x0794,0x0795,0x0798,0x0799,0x079a,0x079b,0x079c,0x079d,  
	0x07a0,0x07a1,0x07a2,0x07a3,0x07a4,0x07a5,0x07a8,0x07a9,  
	0x03aa,0x03ab,0x03ac,0x03ad,0x03b0,0x03b1,0x03b2,0x03b3,
	0x03b4,0x03b5,0x03b8,0x03b9,0x03ba,0x03bb,0x03bb
};

static u8 OFDM_CONFIG[]={
	0x10, 0x0d, 0x01, 0x0C, 0x14, 0xfb, 0x0f, 0x60, 0x00, 0x60,
	0x00, 0x00, 0x00, 0x5c, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00,
	0x00, 0x00, 0xa8, 0x46, 0xb2, 0x33, 0x07, 0xa5, 0x6f, 0x55, 
	0xc8, 0xb3, 0x0a, 0xe1, 0x1c, 0x8a, 0xb6, 0x83, 0x34, 0x0f,
	0x4f, 0x23, 0x6f, 0xc2, 0x6b, 0x40, 0x80, 0x00, 0xc0, 0xc1, 
	0x58, 0xf1, 0x00, 0xe4, 0x90, 0x3e, 0x6d, 0x3c, 0xff, 0x07
};
#endif

  
void
PlatformIOWrite1Byte(
	struct net_device *dev,
	u32		offset,
	u8		data
	)
{
#ifndef CONFIG_RTL8180_IO_MAP
	write_nic_byte(dev, offset, data);
	read_nic_byte(dev, offset); 

#else 
	u32 Page = (offset >> 8);

	switch(Page)
	{
	case 0: 
		write_nic_byte(dev, offset, data);
		break;

	case 1: 
	case 2: 
	case 3: 
		{
			u8 psr = read_nic_byte(dev, PSR);

			write_nic_byte(dev, PSR, ((psr & 0xfc) | (u8)Page)); 
			write_nic_byte(dev, (offset & 0xff), data);
			write_nic_byte(dev, PSR, (psr & 0xfc)); 
		}
		break;
		
	default:
		DMESGE("PlatformIOWrite1Byte(): illegal page number: %d, offset: %#X", Page, offset);
		break;
	}
#endif
}

void
PlatformIOWrite2Byte(
	struct net_device *dev,
	u32		offset,
	u16		data
	)
{
#ifndef CONFIG_RTL8180_IO_MAP
	write_nic_word(dev, offset, data);
	read_nic_word(dev, offset); 


#else 
	u32 Page = (offset >> 8);

	switch(Page)
	{
	case 0: 
		write_nic_word(dev, offset, data);
		break;

	case 1: 
	case 2: 
	case 3: 
		{
			u8 psr = read_nic_byte(dev, PSR);

			write_nic_byte(dev, PSR, ((psr & 0xfc) | (u8)Page)); 
			write_nic_word(dev, (offset & 0xff), data);
			write_nic_byte(dev, PSR, (psr & 0xfc)); 
		}
		break;

	default:
		DMESGE("PlatformIOWrite2Byte(): illegal page number: %d, offset: %#X", Page, offset);
		break;
	}
#endif
}
u8 PlatformIORead1Byte(struct net_device *dev, u32 offset);

void
PlatformIOWrite4Byte(
	struct net_device *dev,
	u32		offset,
	u32		data
	)
{
#ifndef CONFIG_RTL8180_IO_MAP
if (offset == PhyAddr)
	{
		unsigned char	cmdByte;
		unsigned long	dataBytes;
		unsigned char	idx;
		u8	u1bTmp;

		cmdByte = (u8)(data & 0x000000ff);
		dataBytes = data>>8;


		for(idx = 0; idx < 30; idx++)
		{ 
			u1bTmp = PlatformIORead1Byte(dev, PhyAddr);
			if((u1bTmp & BIT7) == 0)
				break;
			else
				mdelay(10);
		}

		for(idx=0; idx < 3; idx++)
		{
			PlatformIOWrite1Byte(dev,offset+1+idx,((u8*)&dataBytes)[idx] );
		}
		write_nic_byte(dev, offset, cmdByte);

	}
	else{
		write_nic_dword(dev, offset, data);
		read_nic_dword(dev, offset); 
	}
#else 
	u32 Page = (offset >> 8);

	switch(Page)
	{
	case 0: 
		write_nic_word(dev, offset, data);
		break;

	case 1: 
	case 2: 
	case 3: 
		{
			u8 psr = read_nic_byte(dev, PSR);

			write_nic_byte(dev, PSR, ((psr & 0xfc) | (u8)Page)); 
			write_nic_dword(dev, (offset & 0xff), data);
			write_nic_byte(dev, PSR, (psr & 0xfc)); 
		}
		break;

	default:
		DMESGE("PlatformIOWrite4Byte(): illegal page number: %d, offset: %#X", Page, offset);
		break;
	}
#endif
}

u8
PlatformIORead1Byte(
	struct net_device *dev,
	u32		offset
	)
{
	u8	data = 0;

#ifndef CONFIG_RTL8180_IO_MAP
	data = read_nic_byte(dev, offset);

#else 
	u32 Page = (offset >> 8);

	switch(Page)
	{
	case 0: 
		data = read_nic_byte(dev, offset);
		break;

	case 1: 
	case 2: 
	case 3: 
		{
			u8 psr = read_nic_byte(dev, PSR);

			write_nic_byte(dev, PSR, ((psr & 0xfc) | (u8)Page)); 
			data = read_nic_byte(dev, (offset & 0xff));
			write_nic_byte(dev, PSR, (psr & 0xfc)); 
		}
		break;

	default:
		DMESGE("PlatformIORead1Byte(): illegal page number: %d, offset: %#X", Page, offset);
		break;
	}
#endif	

	return data;
}

u16
PlatformIORead2Byte(
	struct net_device *dev,
	u32		offset
	)
{
	u16	data = 0;

#ifndef CONFIG_RTL8180_IO_MAP
	data = read_nic_word(dev, offset);

#else 
	u32 Page = (offset >> 8);

	switch(Page)
	{
	case 0: 
		data = read_nic_word(dev, offset);
		break;

	case 1: 
	case 2: 
	case 3: 
		{
			u8 psr = read_nic_byte(dev, PSR);

			write_nic_byte(dev, PSR, ((psr & 0xfc) | (u8)Page)); 
			data = read_nic_word(dev, (offset & 0xff));
			write_nic_byte(dev, PSR, (psr & 0xfc)); 
		}
		break;

	default:
		DMESGE("PlatformIORead2Byte(): illegal page number: %d, offset: %#X", Page, offset);
		break;
	}
#endif

	return data;
}

u32
PlatformIORead4Byte(
	struct net_device *dev,
	u32		offset
	)
{
	u32	data = 0;

#ifndef CONFIG_RTL8180_IO_MAP
	data = read_nic_dword(dev, offset);

#else 
	u32 Page = (offset >> 8);

	switch(Page)
	{
	case 0: 
		data = read_nic_dword(dev, offset); 
		break;

	case 1: 
	case 2: 
	case 3: 
		{
			u8 psr = read_nic_byte(dev, PSR);

			write_nic_byte(dev, PSR, ((psr & 0xfc) | (u8)Page)); 
			data = read_nic_dword(dev, (offset & 0xff));
			write_nic_byte(dev, PSR, (psr & 0xfc)); 
		}
		break;

	default:
		DMESGE("PlatformIORead4Byte(): illegal page number: %d, offset: %#X\n", Page, offset);
		break;
	}
#endif

	return data;
}

void
SetOutputEnableOfRfPins(
	struct net_device *dev
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);

	switch(priv->rf_chip)
	{
	case RFCHIPID_RTL8225:
	case RF_ZEBRA2:
	case RF_ZEBRA4:
		write_nic_word(dev, RFPinsEnable, 0x1bff);
		break;
	}
}

void
ZEBRA_RFSerialWrite(
	struct net_device *dev,
	u32			data2Write,
	u8			totalLength,
	u8			low2high
	)
{
	ThreeWireReg		twreg;
	int 				i;
	u16				oval,oval2,oval3;
	u32				mask;
	u16				UshortBuffer;

	u8			u1bTmp;
#ifdef CONFIG_RTL818X_S 
	u1bTmp = read_nic_byte(dev, RF_SW_CONFIG);
	u1bTmp |=   RF_SW_CFG_SI;   
	write_nic_byte(dev, RF_SW_CONFIG, u1bTmp);
#endif
	UshortBuffer = read_nic_word(dev, RFPinsOutput);
	oval = UshortBuffer & 0xfff8; 
	
	oval2 = read_nic_word(dev, RFPinsEnable);
	oval3 = read_nic_word(dev, RFPinsSelect);

	oval3 &= 0xfff8;
	
	write_nic_word(dev, RFPinsEnable, (oval2|0x0007)); 
	write_nic_word(dev, RFPinsSelect, (oval3|0x0007)); 
	udelay(10);
	
	twreg.longData = 0;
	twreg.struc.enableB = 1;
	write_nic_word(dev, RFPinsOutput, (twreg.longData|oval)); 
	udelay(2);
	twreg.struc.enableB = 0;
	write_nic_word(dev, RFPinsOutput, (twreg.longData|oval)); 
	udelay(10);

	mask = (low2high)?0x01:((u32)0x01<<(totalLength-1));
	
	for(i=0; i<totalLength/2; i++)
	{
		twreg.struc.data = ((data2Write&mask)!=0) ? 1 : 0;
		write_nic_word(dev, RFPinsOutput, (twreg.longData|oval));
		twreg.struc.clk = 1;
		write_nic_word(dev, RFPinsOutput, (twreg.longData|oval));
		write_nic_word(dev, RFPinsOutput, (twreg.longData|oval));
		
		mask = (low2high)?(mask<<1):(mask>>1);
		twreg.struc.data = ((data2Write&mask)!=0) ? 1 : 0;
		write_nic_word(dev, RFPinsOutput, (twreg.longData|oval));
		write_nic_word(dev, RFPinsOutput, (twreg.longData|oval));
		twreg.struc.clk = 0;
		write_nic_word(dev, RFPinsOutput, (twreg.longData|oval));
		mask = (low2high)?(mask<<1):(mask>>1);
	}
	
	twreg.struc.enableB = 1;
	twreg.struc.clk = 0;
	twreg.struc.data = 0;
	write_nic_word(dev, RFPinsOutput, twreg.longData|oval);
	udelay(10);
	
	write_nic_word(dev, RFPinsOutput, oval|0x0004);
	write_nic_word(dev, RFPinsSelect, oval3|0x0000);

	SetOutputEnableOfRfPins(dev);
}


int
HwHSSIThreeWire(
	struct net_device *dev,
	u8			*pDataBuf,
	u8			nDataBufBitCnt,
	int			bSI,
	int			bWrite
	)
{
	int	bResult = 1;
	u8	TryCnt;
	u8	u1bTmp;

	do
	{
		for(TryCnt = 0; TryCnt < TC_3W_POLL_MAX_TRY_CNT; TryCnt++)
		{
			u1bTmp = read_nic_byte(dev, SW_3W_CMD1);
			if( (u1bTmp & (SW_3W_CMD1_RE|SW_3W_CMD1_WE)) == 0 )
			{
				break;
			}
			udelay(10);
		}
		if (TryCnt == TC_3W_POLL_MAX_TRY_CNT) 
			;
          
		u1bTmp = read_nic_byte(dev, RF_SW_CONFIG);

		if(bSI)
		{
			u1bTmp |=   RF_SW_CFG_SI;   
		}else
		{
			u1bTmp &= ~RF_SW_CFG_SI;  
		}

		write_nic_byte(dev, RF_SW_CONFIG, u1bTmp);

		if(bSI)
		{
			u1bTmp = read_nic_byte(dev, RFPinsSelect);
			u1bTmp &= ~BIT3;
			write_nic_byte(dev, RFPinsSelect, u1bTmp );
		}

		if(bWrite)
		{
			if(nDataBufBitCnt == 16)
			{
				write_nic_word(dev, SW_3W_DB0, *((u16*)pDataBuf));
			}
			else if(nDataBufBitCnt == 64)  
			{
				write_nic_dword(dev, SW_3W_DB0, *((u32*)pDataBuf));
				write_nic_dword(dev, SW_3W_DB1, *((u32*)(pDataBuf + 4)));
			}
			else
			{
				int idx;
				int ByteCnt = nDataBufBitCnt / 8;
				if ((nDataBufBitCnt % 8) != 0) 
				printk("HwThreeWire(): nDataBufBitCnt(%d) should be multiple of 8!!!\n", 
				nDataBufBitCnt);

			       if (nDataBufBitCnt > 64) 
				printk("HwThreeWire(): nDataBufBitCnt(%d) should <= 64!!!\n", 
				nDataBufBitCnt);

				for(idx = 0; idx < ByteCnt; idx++)
				{
					write_nic_byte(dev, (SW_3W_DB0+idx), *(pDataBuf+idx));
				}
			}
		}
		else		
		{
			if(bSI)
			{
				write_nic_word(dev, SW_3W_DB0, *((u16*)pDataBuf) );
			}
			else
			{
				write_nic_word(dev, SW_3W_DB0, (*((u16*)pDataBuf)) << 12);
			}
		}
		
		if(bWrite)
		{
			write_nic_byte(dev, SW_3W_CMD1, SW_3W_CMD1_WE);
		}
		else
		{
			write_nic_byte(dev, SW_3W_CMD1, SW_3W_CMD1_RE);
		}

		for(TryCnt = 0; TryCnt < TC_3W_POLL_MAX_TRY_CNT; TryCnt++)
		{
			u1bTmp = read_nic_byte(dev, SW_3W_CMD1);
			if(  (u1bTmp & SW_3W_CMD1_DONE) != 0 )
			{
				break;
			}
			udelay(10);
		}
		
		write_nic_byte(dev, SW_3W_CMD1, 0);

		if(bWrite == 0)
		{
			if(bSI)
			{
				*((u16*)pDataBuf) = read_nic_word(dev, SI_DATA_READ) ;
			}
			else
			{
				*((u16*)pDataBuf) = read_nic_word(dev, PI_DATA_READ);
			}	

			*((u16*)pDataBuf) &= 0x0FFF;
		}
			
	}while(0);

	return bResult;
}
 
int
HwThreeWire(
	struct net_device *dev,
	u8			*pDataBuf,
	u8			nDataBufBitCnt,
	int			bHold,
	int			bWrite
	)
{
	int	bResult = 1;
	u8	TryCnt;
	u8	u1bTmp;

	do
	{
		for(TryCnt = 0; TryCnt < TC_3W_POLL_MAX_TRY_CNT; TryCnt++)
		{
			u1bTmp = read_nic_byte(dev, SW_3W_CMD1);
			if( (u1bTmp & (SW_3W_CMD1_RE|SW_3W_CMD1_WE)) == 0 )
			{
				break;
			}
			udelay(10);
		}
		if (TryCnt == TC_3W_POLL_MAX_TRY_CNT) 
			printk("HwThreeWire(): CmdReg: %#X RE|WE bits are not clear!!\n", u1bTmp);

		if(nDataBufBitCnt == 16)
		{
			write_nic_word(dev, SW_3W_DB0, *((u16 *)pDataBuf));
		}
		else if(nDataBufBitCnt == 64)
		{
			write_nic_dword(dev, SW_3W_DB0, *((u32 *)pDataBuf));
			write_nic_dword(dev, SW_3W_DB1, *((u32 *)(pDataBuf + 4)));
		}
		else
		{
			int idx;
			int ByteCnt = nDataBufBitCnt / 8;

			if ((nDataBufBitCnt % 8) != 0) 
				printk("HwThreeWire(): nDataBufBitCnt(%d) should be multiple of 8!!!\n", 
				nDataBufBitCnt);

			if (nDataBufBitCnt > 64) 
				printk("HwThreeWire(): nDataBufBitCnt(%d) should <= 64!!!\n", 
				nDataBufBitCnt);

			for(idx = 0; idx < ByteCnt; idx++)
			{
				write_nic_byte(dev, (SW_3W_DB0+idx), *(pDataBuf+idx));
			}
		}

		u1bTmp = (u8)(nDataBufBitCnt - 1); 
		if(bHold)
			u1bTmp |= SW_3W_CMD0_HOLD;
		write_nic_byte(dev, SW_3W_CMD0, u1bTmp);

		if(bWrite)
		{
			write_nic_byte(dev, SW_3W_CMD1, SW_3W_CMD1_WE);
		}
		else
		{
			write_nic_byte(dev, SW_3W_CMD1, SW_3W_CMD1_RE);
		}

		for(TryCnt = 0; TryCnt < TC_3W_POLL_MAX_TRY_CNT; TryCnt++)
		{
			u1bTmp = read_nic_byte(dev, SW_3W_CMD1);
			if( (u1bTmp & (SW_3W_CMD1_RE|SW_3W_CMD1_WE)) == 0 && 
				(u1bTmp & SW_3W_CMD1_DONE) != 0 )
			{
				break;
			}
			udelay(10);
		}
		if(TryCnt == TC_3W_POLL_MAX_TRY_CNT)
		{
			write_nic_byte(dev, SW_3W_CMD1, 0);
		}

		if(bWrite == 0)
		{
			if(nDataBufBitCnt == 16)
			{
				*((u16 *)pDataBuf) = read_nic_word(dev, SW_3W_DB0);
			}
			else if(nDataBufBitCnt == 64)
			{
				*((u32 *)pDataBuf) = read_nic_dword(dev, SW_3W_DB0);
				*((u32 *)(pDataBuf + 4)) = read_nic_dword(dev, SW_3W_DB1);
			}
			else
			{
				int idx;
				int ByteCnt = nDataBufBitCnt / 8;
	
				if ((nDataBufBitCnt % 8) != 0) 
					printk("HwThreeWire(): nDataBufBitCnt(%d) should be multiple of 8!!!\n", 
					nDataBufBitCnt);
	
				if (nDataBufBitCnt > 64) 
					printk("HwThreeWire(): nDataBufBitCnt(%d) should <= 64!!!\n", 
					nDataBufBitCnt);
	
				for(idx = 0; idx < ByteCnt; idx++)
				{
					*(pDataBuf+idx) = read_nic_byte(dev, (SW_3W_DB0+idx));
				}
			}	
		}
				
	}while(0);

	return bResult;
}


void
RF_WriteReg(
	struct net_device *dev,
	u8		offset, 
	u32		data
	)
{
	u32			data2Write;
	u8			len;
	u8			low2high;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	

	switch(priv->rf_chip)
	{
	case RFCHIPID_RTL8225:
	case RF_ZEBRA2:		
	case RF_ZEBRA4:        
		switch(priv->RegThreeWireMode)
		{
		case SW_THREE_WIRE:
			{ 
				data2Write = (data << 4) | (u32)(offset & 0x0f);
				len = 16;
				low2high = 0;
				ZEBRA_RFSerialWrite(dev, data2Write, len, low2high);
       			}
			break;

 		case HW_THREE_WIRE:
			{ 
				data2Write = (data << 4) | (u32)(offset & 0x0f);
				len = 16;
				HwThreeWire(
					dev, 
					(u8 *)(&data2Write),	
					len,				
					0,					
					1);					
         		} 
			break;
  #ifdef CONFIG_RTL818X_S
			case HW_THREE_WIRE_PI: 
			{ 
				data2Write = (data << 4) | (u32)(offset & 0x0f);
				len = 16;
					HwHSSIThreeWire(
						dev,
						(u8*)(&data2Write),	
						len,						
						0, 					
						1); 					

			}
			break;
			
			case HW_THREE_WIRE_SI: 
			{ 
				data2Write = (data << 4) | (u32)(offset & 0x0f);
				len = 16;	

				HwHSSIThreeWire(
					dev,
					(u8*)(&data2Write),	
					len,						
					1, 					
					1); 					

			}
			break;
  #endif
 

		default:
			DMESGE("RF_WriteReg(): invalid RegThreeWireMode(%d) !!!", priv->RegThreeWireMode);
			break;
		}
		break;
		
	default:
		DMESGE("RF_WriteReg(): unknown RFChipID: %#X", priv->rf_chip);
		break;
	}
}


void
ZEBRA_RFSerialRead(
	struct net_device *dev,
	u32		data2Write,
	u8		wLength,
	u32		*data2Read,
	u8		rLength,
	u8		low2high
	)
{
	ThreeWireReg	twreg;
	int				i;
	u16			oval,oval2,oval3,tmp, wReg80;
	u32			mask;
	u8			u1bTmp;
	ThreeWireReg	tdata;
#ifdef CONFIG_RTL818X_S
	{ 
		u1bTmp = read_nic_byte(dev, RF_SW_CONFIG);
		u1bTmp |=   RF_SW_CFG_SI;   
		write_nic_byte(dev, RF_SW_CONFIG, u1bTmp);
	}
#endif

	wReg80 = oval = read_nic_word(dev, RFPinsOutput);
	oval2 = read_nic_word(dev, RFPinsEnable);
	oval3 = read_nic_word(dev, RFPinsSelect);

	write_nic_word(dev, RFPinsEnable, oval2|0xf);
	write_nic_word(dev, RFPinsSelect, oval3|0xf);

	*data2Read = 0;

	oval &= ~0xf; 

	twreg.longData = 0;
	twreg.struc.enableB = 1;
	write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(4);

	twreg.longData = 0;
	twreg.struc.enableB = 0;
	twreg.struc.clk = 0;
	twreg.struc.read_write = 0;
	write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(5);

	mask = (low2high) ? 0x01 : ((u32)0x01<<(32-1));
	for(i = 0; i < wLength/2; i++)
	{
		twreg.struc.data = ((data2Write&mask) != 0) ? 1 : 0;
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(1);
		twreg.struc.clk = 1;
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);

		mask = (low2high) ? (mask<<1): (mask>>1);

		if(i == 2)
		{

			twreg.struc.read_write=1;
			write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);
			twreg.struc.clk = 0;
			write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);
			break;
		}
		twreg.struc.data = ((data2Write&mask) != 0) ? 1: 0;
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);

		twreg.struc.clk = 0;
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(1);

		mask = (low2high) ? (mask<<1) : (mask>>1);
	}

	twreg.struc.clk = 0;
	twreg.struc.data = 0;
	write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);
	mask = (low2high) ? 0x01 : ((u32)0x01 << (12-1));

	write_nic_word(dev, RFPinsEnable, ( ((oval2|0x0E) & (~0x01))) );

	for(i = 0; i < rLength; i++)
	{
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(1);
		twreg.struc.clk = 1;
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);
		tmp = read_nic_word(dev, RFPinsInput);
		tdata.longData = tmp;
		*data2Read |= tdata.struc.clk ? mask : 0;

		twreg.struc.clk = 0;
		write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);

		mask = (low2high) ? (mask<<1) : (mask>>1);
	}
	twreg.struc.enableB = 1;
	twreg.struc.clk = 0;
	twreg.struc.data = 0;
	twreg.struc.read_write = 1;
	write_nic_word(dev, RFPinsOutput, twreg.longData|oval); udelay(2);

	write_nic_word(dev, RFPinsEnable, oval2);   
	write_nic_word(dev, RFPinsSelect, oval3);   
	write_nic_word(dev, RFPinsOutput, 0x3a0);
}


u32
RF_ReadReg(
	struct net_device *dev,
	u8		offset
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	u32			data2Write;
	u8			wlen;
	u8			rlen;
	u8			low2high;
	u32			dataRead;

	switch(priv->rf_chip)
	{
	case RFCHIPID_RTL8225:
	case RF_ZEBRA2:
	case RF_ZEBRA4:
		switch(priv->RegThreeWireMode)
		{
#ifdef CONFIG_RTL818X_S
			case HW_THREE_WIRE_PI: 
			{
				data2Write = ((u32)(offset&0x0f)); 
				wlen=16;
				HwHSSIThreeWire(
					dev,
					(u8*)(&data2Write),	
					wlen,					
					0, 					
					0); 					
				dataRead= data2Write;	
			}
			break;

			case HW_THREE_WIRE_SI: 
			{
				data2Write = ((u32)(offset&0x0f)) ; 
				wlen=16;
				HwHSSIThreeWire(
					dev,
					(u8*)(&data2Write),	
					wlen,					
					1, 					
					0					
					); 
				dataRead= data2Write;
			}
			break;
			
#endif
			default:
			{
				data2Write = ((u32)(offset&0x1f)) << 27; 
				wlen = 6;
				rlen = 12;
				low2high = 0;
				ZEBRA_RFSerialRead(dev, data2Write, wlen,&dataRead,rlen, low2high);
			}
			break; 			
		}
		break;
	default:
		dataRead = 0;
		break;
	}

	return dataRead;
}


void
WriteBBPortUchar(
	struct net_device *dev,
	u32		Data
	)
{
	u8	RegisterContent;
	u8	UCharData;

	UCharData = (u8)((Data & 0x0000ff00) >> 8);
	PlatformIOWrite4Byte(dev, PhyAddr, Data);
	{
		PlatformIOWrite4Byte(dev, PhyAddr, Data & 0xffffff7f);
		RegisterContent = PlatformIORead1Byte(dev, PhyDataR);
	}
}

u8
ReadBBPortUchar(
	struct net_device *dev,
	u32		addr
	)
{
	u8	RegisterContent;

	PlatformIOWrite4Byte(dev, PhyAddr, addr & 0xffffff7f);
	RegisterContent = PlatformIORead1Byte(dev, PhyDataR);

	return RegisterContent;
}
#ifdef CONFIG_RTL818X_S
bool
SetAntennaConfig87SE(
	struct net_device *dev,
	u8			DefaultAnt,		
	bool		bAntDiversity 	
)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	bool   bAntennaSwitched = true;
	

	write_phy_cck(dev, 0x0c, 0x09); 
	
	if( bAntDiversity )  
	{
		if( DefaultAnt == 1 )  
		{
			write_nic_byte(dev, ANTSEL, 0x00); 
			
			write_phy_cck(dev, 0x11, 0xbb); 
			write_phy_cck(dev, 0x01, 0xc7); 
			
			write_phy_ofdm(dev, 0x0D, 0x54);   
			write_phy_ofdm(dev, 0x18, 0xb2);  
		}
		else 
		{
			write_nic_byte(dev, ANTSEL, 0x03);
			write_phy_cck(dev, 0x11, 0x9b); 
			write_phy_cck(dev, 0x01, 0xc7); 
			
			write_phy_ofdm(dev, 0x0d, 0x5c);   
			write_phy_ofdm(dev, 0x18, 0xb2);  
		}
	}
	else   
	{
		if( DefaultAnt == 1 ) 
		{
			write_nic_byte(dev, ANTSEL, 0x00); 
			
			write_phy_cck(dev, 0x11, 0xbb); 
			write_phy_cck(dev, 0x01, 0x47); 
			
			write_phy_ofdm(dev, 0x0D, 0x54);   
			write_phy_ofdm(dev, 0x18, 0x32);  
		}
		else 
		{
			write_nic_byte(dev, ANTSEL, 0x03); 
			
			write_phy_cck(dev, 0x11, 0x9b); 
			write_phy_cck(dev, 0x01, 0x47); 
			
			write_phy_ofdm(dev, 0x0D, 0x5c);   
			write_phy_ofdm(dev, 0x18, 0x32);  
		}
	}		
	priv->CurrAntennaIndex = DefaultAnt; 
	return	bAntennaSwitched;
}
#endif

void
ZEBRA_Config_85BASIC_HardCode(
	struct net_device *dev
	)
{

	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	u32			i;
	u32	addr,data;
	u32	u4bRegOffset, u4bRegValue, u4bRF23, u4bRF24;
       u8			u1b24E;

#ifdef CONFIG_RTL818X_S



	RF_WriteReg(dev, 0x00, 0x013f);			mdelay(1); 
	u4bRF23= RF_ReadReg(dev, 0x08);			mdelay(1);
	u4bRF24= RF_ReadReg(dev, 0x09);			mdelay(1);

	if (u4bRF23==0x818 && u4bRF24==0x70C && priv->card_8185 == VERSION_8187S_C) 
		priv->card_8185 = VERSION_8187S_D;

	
	RF_WriteReg(dev, 0x00, 0x009f);      	mdelay(1);

	RF_WriteReg(dev, 0x01, 0x06e0);			mdelay(1);
	
	RF_WriteReg(dev, 0x02, 0x004d);			mdelay(1);
	
	RF_WriteReg(dev, 0x03, 0x07f1);			mdelay(1);

	RF_WriteReg(dev, 0x04, 0x0975);			mdelay(1);
	RF_WriteReg(dev, 0x05, 0x0c72);			mdelay(1);
	RF_WriteReg(dev, 0x06, 0x0ae6);			mdelay(1);
	RF_WriteReg(dev, 0x07, 0x00ca);			mdelay(1);
	RF_WriteReg(dev, 0x08, 0x0e1c);			mdelay(1);
	RF_WriteReg(dev, 0x09, 0x02f0);			mdelay(1);
	RF_WriteReg(dev, 0x0a, 0x09d0);			mdelay(1);
	RF_WriteReg(dev, 0x0b, 0x01ba);			mdelay(1);
	RF_WriteReg(dev, 0x0c, 0x0640);			mdelay(1); 
	RF_WriteReg(dev, 0x0d, 0x08df);			mdelay(1);
	RF_WriteReg(dev, 0x0e, 0x0020);			mdelay(1);
	RF_WriteReg(dev, 0x0f, 0x0990);			mdelay(1); 
	
	
	RF_WriteReg(dev, 0x00, 0x013f);			mdelay(1);

	RF_WriteReg(dev, 0x03, 0x0806);			mdelay(1); 

	if(priv->card_8185 < VERSION_8187S_C)
	{
		RF_WriteReg(dev, 0x04, 0x03f7);			mdelay(1); 
		RF_WriteReg(dev, 0x05, 0x05ab);			mdelay(1);
		RF_WriteReg(dev, 0x06, 0x00c1);			mdelay(1);
	}
	else
	{
		RF_WriteReg(dev, 0x04, 0x03a7);			mdelay(1); 
		RF_WriteReg(dev, 0x05, 0x059b);			mdelay(1);
		RF_WriteReg(dev, 0x06, 0x0081);			mdelay(1);
	}
	

	RF_WriteReg(dev, 0x07, 0x01A0);			mdelay(1);
	RF_WriteReg(dev, 0x0a, 0x0001);			mdelay(1); 
	RF_WriteReg(dev, 0x0b, 0x0418);			mdelay(1);
	
	if(priv->card_8185 == VERSION_8187S_D)
	{
		RF_WriteReg(dev, 0x0c, 0x0fbe);			mdelay(1);
		RF_WriteReg(dev, 0x0d, 0x0008);			mdelay(1); 
		RF_WriteReg(dev, 0x0e, 0x0807);			mdelay(1); 
	}
	else
	{
		RF_WriteReg(dev, 0x0c, 0x0fbe);			mdelay(1);
		RF_WriteReg(dev, 0x0d, 0x0008);			mdelay(1); 
		RF_WriteReg(dev, 0x0e, 0x0806);			mdelay(1); 
	}	
	
	RF_WriteReg(dev, 0x0f, 0x0acc);			mdelay(1); 

	RF_WriteReg(dev, 0x00, 0x01d7);			mdelay(1);

	RF_WriteReg(dev, 0x03, 0x0e00);			mdelay(1);
	RF_WriteReg(dev, 0x04, 0x0e50);			mdelay(1); 
	for(i=0;i<=36;i++)
	{
		RF_WriteReg(dev, 0x01, i);                     mdelay(1); 
		RF_WriteReg(dev, 0x02, ZEBRA_RF_RX_GAIN_TABLE[i]); mdelay(1);
	}
	
	RF_WriteReg(dev, 0x05, 0x0203);			mdelay(1); 	
	RF_WriteReg(dev, 0x06, 0x0200);			mdelay(1);	

	RF_WriteReg(dev, 0x00, 0x0137);			mdelay(1);	
	mdelay(10); 	


	RF_WriteReg(dev, 0x0d, 0x0008);			mdelay(1);	
	mdelay(10); 	

	RF_WriteReg(dev, 0x00, 0x0037);			mdelay(1);	
	mdelay(10); 	

	RF_WriteReg(dev, 0x04, 0x0160);			mdelay(1); 	
	mdelay(10); 	

	RF_WriteReg(dev, 0x07, 0x0080);			mdelay(1);	
	mdelay(10); 	

	RF_WriteReg(dev, 0x02, 0x088D);			mdelay(1);	
	mdelay(200); 	
	mdelay(10); 	
	mdelay(10); 	

	RF_WriteReg(dev, 0x00, 0x0137);			mdelay(1);	
	mdelay(10); 	

	RF_WriteReg(dev, 0x07, 0x0000);			mdelay(1);
	RF_WriteReg(dev, 0x07, 0x0180);			mdelay(1);
	RF_WriteReg(dev, 0x07, 0x0220);			mdelay(1);
	RF_WriteReg(dev, 0x07, 0x03E0);			mdelay(1);
		
	RF_WriteReg(dev, 0x06, 0x00c1);			mdelay(1);
	RF_WriteReg(dev, 0x0a, 0x0001);			mdelay(1);
	if( priv->bXtalCalibration ) 
	{ 
		RF_WriteReg(dev, 0x0f, (priv->XtalCal_Xin<<5)|(priv->XtalCal_Xout<<1)|BIT11|BIT9);			mdelay(1);
		printk("ZEBRA_Config_85BASIC_HardCode(): (%02x)\n", 
				(priv->XtalCal_Xin<<5) | (priv->XtalCal_Xout<<1) | BIT11| BIT9);
	}
	else
	{ 
		RF_WriteReg(dev, 0x0f, 0x0acc);			mdelay(1);  
	}
		
	RF_WriteReg(dev, 0x00, 0x00bf);			mdelay(1); 
	RF_WriteReg(dev, 0x0d, 0x08df);			mdelay(1); 
	RF_WriteReg(dev, 0x02, 0x004d);			mdelay(1); 
	RF_WriteReg(dev, 0x04, 0x0975);			mdelay(1); 
	mdelay(10);	
	mdelay(10);	
	mdelay(10);	
	RF_WriteReg(dev, 0x00, 0x0197);			mdelay(1); 
	RF_WriteReg(dev, 0x05, 0x05ab);			mdelay(1); 
	RF_WriteReg(dev, 0x00, 0x009f);			mdelay(1); 
	
#if 0
	RF_WriteReg(dev, 0x00, 0x0197);			mdelay(1);
	RF_WriteReg(dev, 0x05, 0x05ab);			mdelay(1);
	RF_WriteReg(dev, 0x00, 0x009F);			mdelay(1);
#endif
	RF_WriteReg(dev, 0x01, 0x0000);			mdelay(1); 
	RF_WriteReg(dev, 0x02, 0x0000);			mdelay(1); 
	u1b24E = read_nic_byte(dev, 0x24E);
	write_nic_byte(dev, 0x24E, (u1b24E & (~(BIT5|BIT6))));
	

	
#if 0	
	write_nic_dword(dev, PHY_ADR, 0x0100c880);
	write_nic_dword(dev, PHY_ADR, 0x01001c86);
	write_nic_dword(dev, PHY_ADR, 0x01007890);
	write_nic_dword(dev, PHY_ADR, 0x0100d0ae);
	write_nic_dword(dev, PHY_ADR, 0x010006af);
	write_nic_dword(dev, PHY_ADR, 0x01004681);
#endif
	write_phy_cck(dev,0x00,0xc8);
	write_phy_cck(dev,0x06,0x1c);
	write_phy_cck(dev,0x10,0x78);
	write_phy_cck(dev,0x2e,0xd0);
	write_phy_cck(dev,0x2f,0x06);
	write_phy_cck(dev,0x01,0x46);

	write_nic_byte(dev, CCK_TXAGC, 0x10);
	write_nic_byte(dev, OFDM_TXAGC, 0x1B);
	write_nic_byte(dev, ANTSEL, 0x03);
#else

	RF_WriteReg(dev, 0x00, 0x00b7);			mdelay(1);
	RF_WriteReg(dev, 0x01, 0x0ee0);			mdelay(1);
	RF_WriteReg(dev, 0x02, 0x044d);			mdelay(1);
	RF_WriteReg(dev, 0x03, 0x0441);			mdelay(1);
	RF_WriteReg(dev, 0x04, 0x08c3);			mdelay(1);
	RF_WriteReg(dev, 0x05, 0x0c72);			mdelay(1);
	RF_WriteReg(dev, 0x06, 0x00e6);			mdelay(1);
	RF_WriteReg(dev, 0x07, 0x082a);			mdelay(1);
	RF_WriteReg(dev, 0x08, 0x003f);			mdelay(1);
	RF_WriteReg(dev, 0x09, 0x0335);			mdelay(1);
	RF_WriteReg(dev, 0x0a, 0x09d4);			mdelay(1);
	RF_WriteReg(dev, 0x0b, 0x07bb);			mdelay(1);
	RF_WriteReg(dev, 0x0c, 0x0850);			mdelay(1);
	RF_WriteReg(dev, 0x0d, 0x0cdf);			mdelay(1);
	RF_WriteReg(dev, 0x0e, 0x002b);			mdelay(1);
	RF_WriteReg(dev, 0x0f, 0x0114);			mdelay(1);

	RF_WriteReg(dev, 0x00, 0x01b7);			mdelay(1);


	for(i=1;i<=95;i++)
	{
		RF_WriteReg(dev, 0x01, i);	mdelay(1); 
		RF_WriteReg(dev, 0x02, ZEBRA_RF_RX_GAIN_TABLE[i]); mdelay(1);
	}
	
	RF_WriteReg(dev, 0x03, 0x0080);			mdelay(1); 	
	RF_WriteReg(dev, 0x05, 0x0004);			mdelay(1);	
	RF_WriteReg(dev, 0x00, 0x00b7);			mdelay(1);	
	RF_WriteReg(dev, 0x02, 0x0c4d);			mdelay(1);
	mdelay(100);	
	mdelay(100);	
	RF_WriteReg(dev, 0x02, 0x044d);			mdelay(1); 	
	RF_WriteReg(dev, 0x00, 0x02bf);			mdelay(1);	
	

	


	write_nic_byte(dev, CCK_TXAGC, 0x03);
	write_nic_byte(dev, OFDM_TXAGC, 0x07);
	write_nic_byte(dev, ANTSEL, 0x03);


#endif


	

	write_phy_ofdm(dev, 0x00, 0x12);

	for (i=0; i<128; i++)
	{
		
		data = ZEBRA_AGC[i+1];
		data = data << 8;
		data = data | 0x0000008F;

		addr = i + 0x80; 
		addr = addr << 8;
		addr = addr | 0x0000008E;

		WriteBBPortUchar(dev, data); 	       
		WriteBBPortUchar(dev, addr); 	    
		WriteBBPortUchar(dev, 0x0000008E);
	}

	PlatformIOWrite4Byte( dev, PhyAddr, 0x00001080);	
					
	

	for(i=0; i<60; i++)
	{
		u4bRegOffset=i;
		u4bRegValue=OFDM_CONFIG[i];
		
	
		WriteBBPortUchar(dev, 
						(0x00000080 | 
						(u4bRegOffset & 0x7f) | 
						((u4bRegValue & 0xff) << 8)));
	} 

#ifdef CONFIG_RTL818X_S
	SetAntennaConfig87SE(dev, priv->bDefaultAntenna1, priv->bSwAntennaDiverity);	
#endif
#if 0
	if( priv->bSwAntennaDiverity )  
	{
		if( priv->bDefaultAntenna1 == true )  
		{
			write_nic_byte(dev, ANTSEL, 0x00); 
			write_phy_cck(dev, 0x11, 0xbb); 
			write_phy_cck(dev, 0x0c, 0x09); 
			write_phy_cck(dev, 0x01, 0xc7); 
			write_phy_ofdm(dev, 0x0d, 0x54);   
			write_phy_ofdm(dev, 0x18, 0xb2);  
		}
		else 
		{
			write_nic_byte(dev, ANTSEL, 0x03);
			write_phy_cck(dev, 0x11, 0x9b); 
			write_phy_cck(dev, 0x0c, 0x09); 
			write_phy_cck(dev, 0x01, 0xc7); 
			write_phy_ofdm(dev, 0x0d, 0x5c);   
			write_phy_ofdm(dev, 0x18, 0xb2);  
		}
	}
	else   
	{
		if( priv->bDefaultAntenna1 == true ) 
		{
			write_nic_byte(dev, ANTSEL, 0x00); 
			write_phy_cck(dev, 0x11, 0xbb); 
			write_phy_cck(dev, 0x0c, 0x09); 
			write_phy_cck(dev, 0x01, 0x47); 
			write_phy_ofdm(dev, 0x0d, 0x54);   
			write_phy_ofdm(dev, 0x18, 0x32);  
		}
		else 
		{
			write_nic_byte(dev, ANTSEL, 0x03); 
			write_phy_cck(dev, 0x11, 0x9b); 
			write_phy_cck(dev, 0x0c, 0x09); 
			write_phy_cck(dev, 0x01, 0x47); 
			write_phy_ofdm(dev, 0x0d, 0x5c);   
			write_phy_ofdm(dev, 0x18, 0x32);  
		}
	}
#endif
}


void
UpdateInitialGain(
	struct net_device *dev
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);

	if(priv->eRFPowerState != eRfOn)
	{
		priv->InitialGain= priv->InitialGainBackUp;
		return;
	}
		
	switch(priv->rf_chip)
	{
#if 0
	case RF_ZEBRA2:
		switch(priv->InitialGain)
		{
			case 1: 
				DMESG("RTL8185B + 8225 Initial Gain State 1: -82 dBm \n");
				write_nic_dword(dev, PhyAddr, 0x2697);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0x86a4);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xfa85);	mdelay(1);
				break;
					
			case 2: 
				DMESG("RTL8185B + 8225 Initial Gain State 2: -82 dBm \n");
				write_nic_dword(dev, PhyAddr, 0x2697);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0x86a4);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xfb85);	mdelay(1);
				break;

			case 3: 
				DMESG("RTL8185B + 8225 Initial Gain State 3: -82 dBm \n");
				write_nic_dword(dev, PhyAddr, 0x2697);	mdelay(1);				
				write_nic_dword(dev, PhyAddr, 0x96a4);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xfb85);	mdelay(1);
				break;

			case 4: 
				DMESG("RTL8185B + 8225 Initial Gain State 4: -78 dBm \n");
				write_nic_dword(dev, PhyAddr, 0x2697);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xa6a4);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xfb85);	mdelay(1);
				break;

			case 5: 
				DMESG("RTL8185B + 8225 Initial Gain State 5: -74 dBm \n");
				write_nic_dword(dev, PhyAddr, 0x3697);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xa6a4);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xfb85);	mdelay(1);
				break;

			case 6: 
				DMESG("RTL8185B + 8225 Initial Gain State 6: -70 dBm \n");
				write_nic_dword(dev, PhyAddr, 0x4697);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xa6a4);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xfb85);	mdelay(1);
				break;

			case 7: 
				DMESG("RTL8185B + 8225 Initial Gain State 7: -66 dBm \n");
				write_nic_dword(dev, PhyAddr, 0x5697);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xa6a4);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xfb85);	mdelay(1);
				break;

			default:	
				DMESG("RTL8185B + 8225 Initial Gain State 1: -82 dBm (default)\n");
				write_nic_dword(dev, PhyAddr, 0x2697);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0x86a4);	mdelay(1);
				write_nic_dword(dev, PhyAddr, 0xfa85);	mdelay(1);
				break;	
		}		
		break;
#endif
	case RF_ZEBRA4:
		switch(priv->InitialGain)
		{
			case 1: 
				write_phy_ofdm(dev, 0x17, 0x26);	mdelay(1);
				write_phy_ofdm(dev, 0x24, 0x86);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfa);	mdelay(1);
				break;
					
			case 2: 
				write_phy_ofdm(dev, 0x17, 0x36);	mdelay(1);
				write_phy_ofdm(dev, 0x24, 0x86);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfa);	mdelay(1);
				break;

			case 3: 
				write_phy_ofdm(dev, 0x17, 0x36);	mdelay(1);				
				write_phy_ofdm(dev, 0x24, 0x86);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfb);	mdelay(1);
				break;

			case 4: 
				write_phy_ofdm(dev, 0x17, 0x46);	mdelay(1);
				write_phy_ofdm(dev, 0x24, 0x86);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfb);	mdelay(1);
				break;

			case 5: 
				write_phy_ofdm(dev, 0x17, 0x46);	mdelay(1);
				write_phy_ofdm(dev, 0x24, 0x96);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfb);	mdelay(1);
				break;

			case 6: 
				write_phy_ofdm(dev, 0x17, 0x56);	mdelay(1);
				write_phy_ofdm(dev, 0x24, 0x96);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfc);	mdelay(1);
				break;

			case 7: 
				write_phy_ofdm(dev, 0x17, 0x56);	mdelay(1);
				write_phy_ofdm(dev, 0x24, 0xa6);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfc);	mdelay(1);
				break;

			case 8:
				write_phy_ofdm(dev, 0x17, 0x66);	mdelay(1);
				write_phy_ofdm(dev, 0x24, 0xb6);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfc);	mdelay(1);
				break;
					

			default:	
				write_phy_ofdm(dev, 0x17, 0x26);	mdelay(1);
				write_phy_ofdm(dev, 0x24, 0x86);	mdelay(1);
				write_phy_ofdm(dev, 0x05, 0xfa);	mdelay(1);
				break;	
		}		
		break;

	
	default:
		DMESG("UpdateInitialGain(): unknown RFChipID: %#X\n", priv->rf_chip);
		break;
	}
}
#ifdef CONFIG_RTL818X_S
void
InitTxPwrTracking87SE(
	struct net_device *dev
)
{
	u32	u4bRfReg;

	u4bRfReg = RF_ReadReg(dev, 0x02); 
	
	RF_WriteReg(dev, 0x02, u4bRfReg|PWR_METER_EN);			mdelay(1);
}

#endif
void
PhyConfig8185(
	struct net_device *dev
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
       write_nic_dword(dev, RCR, priv->ReceiveConfig);
	   priv->RFProgType = read_nic_byte(dev, CONFIG4) & 0x03;
	switch(priv->rf_chip)
	{
	case RF_ZEBRA2:
	case RF_ZEBRA4:
		ZEBRA_Config_85BASIC_HardCode( dev);
		break;
	}
#ifdef CONFIG_RTL818X_S
	if(priv->bDigMechanism)
	{
		if(priv->InitialGain == 0)
			priv->InitialGain = 4;
	}

	if(priv->bTxPowerTrack)
		InitTxPwrTracking87SE(dev);		
	
#endif
	priv->InitialGainBackUp= priv->InitialGain;
	UpdateInitialGain(dev);
     
	return;
}




void
HwConfigureRTL8185(
		struct net_device *dev
		)
{
        u8              bUNIVERSAL_CONTROL_RL = 0;

	u8		bUNIVERSAL_CONTROL_AGC = 1;
	u8		bUNIVERSAL_CONTROL_ANT = 1;
	u8		bAUTO_RATE_FALLBACK_CTL = 1; 
	u8		val8;
        write_nic_word(dev, BRSR, 0x0fff);	
	val8 = read_nic_byte(dev, CW_CONF);
	
	if(bUNIVERSAL_CONTROL_RL)
		val8 = val8 & 0xfd;
	else
		val8 = val8 | 0x02;
		
	write_nic_byte(dev, CW_CONF, val8);
	
	val8 = read_nic_byte(dev, TXAGC_CTL);
	if(bUNIVERSAL_CONTROL_AGC)
	{
		write_nic_byte(dev, CCK_TXAGC, 128);
		write_nic_byte(dev, OFDM_TXAGC, 128);
		val8 = val8 & 0xfe;
	}
	else
	{
		val8 = val8 | 0x01 ;
	}
		

	write_nic_byte(dev, TXAGC_CTL, val8);
	
	val8 = read_nic_byte(dev, TXAGC_CTL );

	if(bUNIVERSAL_CONTROL_ANT)
	{
		write_nic_byte(dev, ANTSEL, 0x00);
		val8 = val8 & 0xfd;
	}
	else
	{
		val8 = val8 & (val8|0x02); 
	}
		
	write_nic_byte(dev, TXAGC_CTL, val8);
	
	val8 = read_nic_byte(dev, RATE_FALLBACK);
	val8 &= 0x7c;
	if( bAUTO_RATE_FALLBACK_CTL )
	{
		val8 |= RATE_FALLBACK_CTL_ENABLE | RATE_FALLBACK_CTL_AUTO_STEP1;

#if 0
		PlatformIOWrite2Byte(dev, ARFR, 0x0fff); 	
#endif
#ifdef CONFIG_RTL818X_S
	        PlatformIOWrite2Byte(dev, ARFR, 0x0fff); 
#else
		PlatformIOWrite2Byte(dev, ARFR, 0x0c00); 
#endif
	}
	else
	{
	}
	write_nic_byte(dev, RATE_FALLBACK, val8);
}



static void
MacConfig_85BASIC_HardCode(
	struct net_device *dev)
{	
	int			nLinesRead = 0;

	u32	u4bRegOffset, u4bRegValue,u4bPageIndex = 0;
	int	i;

	nLinesRead=sizeof(MAC_REG_TABLE)/2;
		
	for(i = 0; i < nLinesRead; i++)  
	{
		u4bRegOffset=MAC_REG_TABLE[i][0]; 
		u4bRegValue=MAC_REG_TABLE[i][1]; 
				
                if(u4bRegOffset == 0x5e)
                {
                    u4bPageIndex = u4bRegValue;
                }
                else
                {
                    u4bRegOffset |= (u4bPageIndex << 8);
                }
		write_nic_byte(dev, u4bRegOffset, (u8)u4bRegValue); 
	}
}



static void
MacConfig_85BASIC(
	struct net_device *dev)
{

       u8			u1DA;
	MacConfig_85BASIC_HardCode(dev);

		
	write_nic_word(dev, TID_AC_MAP, 0xfa50);

	write_nic_word(dev, IntMig, 0x0000);

	PlatformIOWrite4Byte(dev, 0x1F0, 0x00000000);
	PlatformIOWrite4Byte(dev, 0x1F4, 0x00000000);
	PlatformIOWrite1Byte(dev, 0x1F8, 0x00);

#if 0
	write_nic_dword(dev, RFTiming, 0x00004001);
#endif
#ifdef CONFIG_RTL818X_S

	u1DA = read_nic_byte(dev, PHYPR);
	write_nic_byte(dev, PHYPR, (u1DA | BIT2) );

	write_nic_word(dev, 0x360, 0x1000);
	write_nic_word(dev, 0x362, 0x1000);
	
	write_nic_word(dev, 0x370, 0x0560);
	write_nic_word(dev, 0x372, 0x0560);
	write_nic_word(dev, 0x374, 0x0DA4);
	write_nic_word(dev, 0x376, 0x0DA4);
	write_nic_word(dev, 0x378, 0x0560);
	write_nic_word(dev, 0x37A, 0x0560);
	write_nic_word(dev, 0x37C, 0x00EC);
	write_nic_word(dev, 0x37E, 0x00EC);
#else
       write_nic_dword(dev, RFTiming, 0x00004003);
#endif
       write_nic_byte(dev, 0x24E,0x01);

}




u8
GetSupportedWirelessMode8185(
	struct net_device *dev
)
{
	u8			btSupportedWirelessMode = 0;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);

	switch(priv->rf_chip)
	{
	case RF_ZEBRA2:
	case RF_ZEBRA4:
		btSupportedWirelessMode = (WIRELESS_MODE_B | WIRELESS_MODE_G);
		break;
	default:
		btSupportedWirelessMode = WIRELESS_MODE_B;
		break;
	}

	return btSupportedWirelessMode;
}

void
ActUpdateChannelAccessSetting(
	struct net_device *dev,
	WIRELESS_MODE			WirelessMode,
	PCHANNEL_ACCESS_SETTING	ChnlAccessSetting
	)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	struct ieee80211_device *ieee = priv->ieee80211;
	AC_CODING	eACI;
	AC_PARAM	AcParam;
	u8	bFollowLegacySetting = 0;
	u8   u1bAIFS;

	ChnlAccessSetting->SIFS_Timer = 0x22; 
	ChnlAccessSetting->DIFS_Timer = 0x1C; 
	ChnlAccessSetting->SlotTimeTimer = 9; 
	ChnlAccessSetting->EIFS_Timer = 0x5B; 
	ChnlAccessSetting->CWminIndex = 3; 
	ChnlAccessSetting->CWmaxIndex = 7; 

	write_nic_byte(dev, SIFS, ChnlAccessSetting->SIFS_Timer);
	write_nic_byte(dev, SLOT, ChnlAccessSetting->SlotTimeTimer);	

	u1bAIFS = aSifsTime + (2 * ChnlAccessSetting->SlotTimeTimer );


	write_nic_byte(dev, EIFS, ChnlAccessSetting->EIFS_Timer);

	write_nic_byte(dev, AckTimeOutReg, 0x5B); 

#ifdef TODO
	if( pStaQos->CurrentQosMode > QOS_DISABLE )
	{ 
		if(pStaQos->QBssWirelessMode == WirelessMode)
		{
			for(eACI = 0; eACI < AC_MAX; eACI++)
			{
				Adapter->HalFunc.SetHwRegHandler(Adapter, HW_VAR_AC_PARAM, (pu1Byte)(&(pStaQos->WMMParamEle.AcParam[eACI])) );
			}
		}
		else
		{
			bFollowLegacySetting = 1;
		}
	}	
	else
#endif		
	{ 
		bFollowLegacySetting = 1;

	}

	if(bFollowLegacySetting)
	{


		AcParam.longData = 0;
		AcParam.f.AciAifsn.f.AIFSN = 2; 
		AcParam.f.AciAifsn.f.ACM = 0;
		AcParam.f.Ecw.f.ECWmin = ChnlAccessSetting->CWminIndex; 
		AcParam.f.Ecw.f.ECWmax = ChnlAccessSetting->CWmaxIndex; 
		AcParam.f.TXOPLimit = 0;

#if 1
#ifdef THOMAS_TURBO
		if( ieee->current_network.Turbo_Enable == 1 )				
			AcParam.f.TXOPLimit = 0x01FF;
#endif
		if (ieee->iw_mode == IW_MODE_ADHOC)
			AcParam.f.TXOPLimit = 0x0020;
#endif

		for(eACI = 0; eACI < AC_MAX; eACI++)
		{
			AcParam.f.AciAifsn.f.ACI = (u8)eACI;
			{
				PAC_PARAM	pAcParam = (PAC_PARAM)(&AcParam);
				AC_CODING	eACI;
				u8		u1bAIFS;
				u32		u4bAcParam;

				eACI = pAcParam->f.AciAifsn.f.ACI; 
				u1bAIFS = pAcParam->f.AciAifsn.f.AIFSN * ChnlAccessSetting->SlotTimeTimer + aSifsTime; 
				u4bAcParam = (	(((u32)(pAcParam->f.TXOPLimit)) << AC_PARAM_TXOP_LIMIT_OFFSET)	| 
						(((u32)(pAcParam->f.Ecw.f.ECWmax)) << AC_PARAM_ECW_MAX_OFFSET)	|  
						(((u32)(pAcParam->f.Ecw.f.ECWmin)) << AC_PARAM_ECW_MIN_OFFSET)	|  
						(((u32)u1bAIFS) << AC_PARAM_AIFS_OFFSET));

				switch(eACI)
				{
					case AC1_BK:
						break;

					case AC0_BE:
						break;

					case AC2_VI:
						break;

					case AC3_VO:
						break;

					default:
						DMESGW( "SetHwReg8185(): invalid ACI: %d !\n", eACI);
						break;
				}

				{
					PACI_AIFSN	pAciAifsn = (PACI_AIFSN)(&pAcParam->f.AciAifsn);
					AC_CODING	eACI = pAciAifsn->f.ACI;

#ifdef TODO				
					u8	AcmCtrl = pHalData->AcmControl;
#else
					u8	AcmCtrl = 0;	
#endif
					if( pAciAifsn->f.ACM )
					{ 
						switch(eACI)
						{
							case AC0_BE:
								AcmCtrl |= (BEQ_ACM_EN|BEQ_ACM_CTL|ACM_HW_EN);	
								break;

							case AC2_VI:
								AcmCtrl |= (VIQ_ACM_EN|VIQ_ACM_CTL|ACM_HW_EN);	
								break;

							case AC3_VO:
								AcmCtrl |= (VOQ_ACM_EN|VOQ_ACM_CTL|ACM_HW_EN);	
								break;

							default:
								DMESGW("SetHwReg8185(): [HW_VAR_ACM_CTRL] ACM set failed: eACI is %d\n", eACI );
								break;
						}
					}
					else
					{ 
						switch(eACI)
						{
							case AC0_BE:
								AcmCtrl &= ( (~BEQ_ACM_EN) & (~BEQ_ACM_CTL) & (~ACM_HW_EN) );	
								break;

							case AC2_VI:
								AcmCtrl &= ( (~VIQ_ACM_EN) & (~VIQ_ACM_CTL) & (~ACM_HW_EN) );	
								break;

							case AC3_VO:
								AcmCtrl &= ( (~VOQ_ACM_EN) & (~VOQ_ACM_CTL) & (~ACM_HW_EN) );	
								break;

							default:
								break;
						}
					}


#ifdef TO_DO
					pHalData->AcmControl = AcmCtrl;
#endif				
					write_nic_byte(dev, ACM_CONTROL, 0);
				}
			}
		}
	

	}
}

void
ActSetWirelessMode8185(
	struct net_device *dev,
	u8				btWirelessMode
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct ieee80211_device *ieee = priv->ieee80211;
	u8	btSupportedWirelessMode = GetSupportedWirelessMode8185(dev);
	
	if( (btWirelessMode & btSupportedWirelessMode) == 0 )
	{ 
		DMESGW("ActSetWirelessMode8185(): WirelessMode(%d) is not supported (%d)!\n", 
			btWirelessMode, btSupportedWirelessMode);
		return;
	}	

	if (btWirelessMode == WIRELESS_MODE_AUTO) 
	{
		if((btSupportedWirelessMode & WIRELESS_MODE_A))
		{
			btWirelessMode = WIRELESS_MODE_A;
		}
		else if((btSupportedWirelessMode & WIRELESS_MODE_G))
		{
			btWirelessMode = WIRELESS_MODE_G;
		}
		else if((btSupportedWirelessMode & WIRELESS_MODE_B))
		{
			btWirelessMode = WIRELESS_MODE_B;
		}
		else
		{
			DMESGW("ActSetWirelessMode8185(): No valid wireless mode supported, btSupportedWirelessMode(%x)!!!\n", 
					 btSupportedWirelessMode);
			btWirelessMode = WIRELESS_MODE_B;
		}
	}
	
	
	switch(priv->rf_chip)
	{
	case RF_ZEBRA2:
	case RF_ZEBRA4:
		{
			ieee->mode = (WIRELESS_MODE)btWirelessMode;
		}
		break;

	default:
		DMESGW("ActSetWirelessMode8185(): unsupported RF: 0x%X !!!\n", priv->rf_chip);
		break;
	}
	
	if( ieee->mode == WIRELESS_MODE_A ){
		DMESG("WIRELESS_MODE_A\n"); 
	}
	else if( ieee->mode == WIRELESS_MODE_B ){
		DMESG("WIRELESS_MODE_B\n"); 
	}
	else if( ieee->mode == WIRELESS_MODE_G ){
		DMESG("WIRELESS_MODE_G\n"); 
	}
	
	ActUpdateChannelAccessSetting( dev, ieee->mode, &priv->ChannelAccessSetting);
}

void rtl8185b_irq_enable(struct net_device *dev)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);	

	priv->irq_enabled = 1;
	write_nic_dword(dev, IMR, priv->IntrMask);
}
void
DrvIFIndicateDisassociation(
	struct net_device *dev,
	u16			reason
	)
{

	
}
void
MgntDisconnectIBSS(
	struct net_device *dev
) 
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	u8			i;


	DrvIFIndicateDisassociation(dev, unspec_reason);

	for(i=0;i<6;i++)  priv->ieee80211->current_network.bssid[i] = 0x55;

	priv->ieee80211->state = IEEE80211_NOLINK;


	
	ieee80211_stop_send_beacons(priv->ieee80211);

	priv->ieee80211->link_change(dev);
	notify_wx_assoc_event(priv->ieee80211);

#if 0
	if(pMgntInfo->bEnableSwBeaconTimer)
	{
		PlatformCancelTimer( Adapter, &pMgntInfo->SwBeaconTimer);
	}
#endif


}
void
MlmeDisassociateRequest(
	struct net_device *dev,
	u8*			asSta,
	u8			asRsn
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	u8 i;

	SendDisassociation(priv->ieee80211, asSta, asRsn );

	if( memcmp(priv->ieee80211->current_network.bssid, asSta, 6 ) == 0 ){
		DrvIFIndicateDisassociation(dev, unspec_reason);
		
		
		for(i=0;i<6;i++)  priv->ieee80211->current_network.bssid[i] = 0x22;

		ieee80211_disassociate(priv->ieee80211);
		
		
	}

}

void
MgntDisconnectAP(
	struct net_device *dev,
	u8			asRsn
) 
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);


#ifdef TODO
	if(   pMgntInfo->SecurityInfo.AuthMode > RT_802_11AuthModeAutoSwitch ||
		(pMgntInfo->bAPSuportCCKM && pMgntInfo->bCCX8021xenable) )  
	{
		SecClearAllKeys(Adapter);
		RT_TRACE(COMP_SEC, DBG_LOUD,("======>CCKM clear key..."))
	}
#endif
	MlmeDisassociateRequest( dev, priv->ieee80211->current_network.bssid, asRsn );

	priv->ieee80211->state = IEEE80211_NOLINK;
}
bool
MgntDisconnect(
	struct net_device *dev,
	u8			asRsn
) 
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
#ifdef TODO
	if(pMgntInfo->mPss != eAwake)
	{
		PlatformSetTimer( Adapter, &(pMgntInfo->AwakeTimer), 0 );
	}
#endif

#ifdef ENABLE_DOT11D
	if(IS_DOT11D_ENABLE(priv->ieee80211))
		Dot11d_Reset(priv->ieee80211);
#endif
	if( priv->ieee80211->state == IEEE80211_LINKED )
	{
		if( priv->ieee80211->iw_mode == IW_MODE_ADHOC )
		{
			MgntDisconnectIBSS(dev);
		}
		if( priv->ieee80211->iw_mode == IW_MODE_INFRA )
		{

			MgntDisconnectAP(dev, asRsn);
		}

	}

	return true;
}
bool
SetRFPowerState(
	struct net_device *dev, 
	RT_RF_POWER_STATE	eRFPowerState
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	bool			bResult = false;

	if(eRFPowerState == priv->eRFPowerState)
	{
		return bResult;
	}

	switch(priv->rf_chip)
	{
		case RF_ZEBRA2:
		case RF_ZEBRA4:
			 bResult = SetZebraRFPowerState8185(dev, eRFPowerState);
			break;

		default:
			printk("SetRFPowerState8185(): unknown RFChipID: 0x%X!!!\n", priv->rf_chip);
			break;;
}

	return bResult;
}
void
HalEnableRx8185Dummy(
	struct net_device *dev
	)
{		
}
void
HalDisableRx8185Dummy(
	struct net_device *dev
	)
{		
}

bool
MgntActSet_RF_State(
	struct net_device *dev,
	RT_RF_POWER_STATE	StateToSet,
	u32	ChangeSource
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	bool				bActionAllowed = false; 
	bool				bConnectBySSID = false;
	RT_RF_POWER_STATE 	rtState;
	u16				RFWaitCounter = 0;
	unsigned long flag;
#if 1 
	while(true)
	{
		spin_lock_irqsave(&priv->rf_ps_lock,flag);
		if(priv->RFChangeInProgress)
		{
			spin_unlock_irqrestore(&priv->rf_ps_lock,flag);			
			while(priv->RFChangeInProgress)
			{
				RFWaitCounter ++;
				udelay(1000); 

				if(RFWaitCounter > 1000) 
				{
					printk("MgntActSet_RF_State(): Wait too long to set RF\n");
					return false;
				}
			}
		}
		else
		{
			priv->RFChangeInProgress = true;
			spin_unlock_irqrestore(&priv->rf_ps_lock,flag);
			break;
		}
	}
#endif
	rtState = priv->eRFPowerState;	


	switch(StateToSet) 
	{
	case eRfOn:
		priv->RfOffReason &= (~ChangeSource);

		if(! priv->RfOffReason)
		{
			priv->RfOffReason = 0;
			bActionAllowed = true;

			if(rtState == eRfOff && ChangeSource >=RF_CHANGE_BY_HW && !priv->bInHctTest)
			{
				bConnectBySSID = true;
			}
		}
		else
			;
		break;

	case eRfOff:
		
			if (priv->RfOffReason > RF_CHANGE_BY_IPS)
			{

				MgntDisconnect( dev, disas_lv_ss );	
				
			}
		
		

		priv->RfOffReason |= ChangeSource;
		bActionAllowed = true;
		break;

	case eRfSleep:
		priv->RfOffReason |= ChangeSource;
		bActionAllowed = true;
		break;

	default:
		break;
	}

	if(bActionAllowed)
	{
		SetRFPowerState(dev, StateToSet);
			
		if(StateToSet == eRfOn) 
		{				
			HalEnableRx8185Dummy(dev);
			if(bConnectBySSID)
			{	
			}
		}
		else if(StateToSet == eRfOff)
		{		
			HalDisableRx8185Dummy(dev);
		}		
	}
	else
	{
	}

	spin_lock_irqsave(&priv->rf_ps_lock,flag);
	priv->RFChangeInProgress = false;
	spin_unlock_irqrestore(&priv->rf_ps_lock,flag);
	return bActionAllowed;
}
void
InactivePowerSave(
	struct net_device *dev
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);

	priv->bSwRfProcessing = true;

	MgntActSet_RF_State(dev, priv->eInactivePowerState, RF_CHANGE_BY_IPS);

#if 0
	while( index < 4 )
	{
		if( ( pMgntInfo->SecurityInfo.PairwiseEncAlgorithm == WEP104_Encryption ) ||
			(pMgntInfo->SecurityInfo.PairwiseEncAlgorithm == WEP40_Encryption) )
		{
			if( pMgntInfo->SecurityInfo.KeyLen[index] != 0)
			pAdapter->HalFunc.SetKeyHandler(pAdapter, index, 0, FALSE, pMgntInfo->SecurityInfo.PairwiseEncAlgorithm, TRUE, FALSE);

		}
		index++;
	}
#endif
	priv->bSwRfProcessing = false;	
}

void
IPSEnter(
	struct net_device *dev
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	RT_RF_POWER_STATE rtState;
	if (priv->bInactivePs)
	{
		rtState = priv->eRFPowerState;
		
		if (rtState == eRfOn && !priv->bSwRfProcessing 
			&& (priv->ieee80211->state != IEEE80211_LINKED ))
		{
			priv->eInactivePowerState = eRfOff;
			InactivePowerSave(dev);
		}
	}
}
void
IPSLeave(
	struct net_device *dev
	)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	RT_RF_POWER_STATE rtState;
	if (priv->bInactivePs)
	{	
		rtState = priv->eRFPowerState;	
		if ((rtState == eRfOff || rtState == eRfSleep) && (!priv->bSwRfProcessing) && priv->RfOffReason <= RF_CHANGE_BY_IPS)
		{
			priv->eInactivePowerState = eRfOn;
			InactivePowerSave(dev);
		}
	}
}
void rtl8185b_adapter_start(struct net_device *dev)
{
      struct r8180_priv *priv = ieee80211_priv(dev);
	struct ieee80211_device *ieee = priv->ieee80211;
 
	u8 SupportedWirelessMode;
	u8			InitWirelessMode;
	u8			bInvalidWirelessMode = 0;	
	u8 tmpu8;
	u8 btCR9346;
	u8 TmpU1b;
	u8 btPSR;

	write_nic_byte(dev,0x24e, (BIT5|BIT6|BIT0));
	rtl8180_reset(dev);

	priv->dma_poll_mask = 0;
	priv->dma_poll_stop_mask = 0;


	HwConfigureRTL8185(dev);

	write_nic_dword(dev, MAC0, ((u32*)dev->dev_addr)[0]);
	write_nic_word(dev, MAC4, ((u32*)dev->dev_addr)[1] & 0xffff );

	write_nic_byte(dev, MSR, read_nic_byte(dev, MSR) & 0xf3);	

	
	write_nic_word(dev, BcnItv, 100);
	write_nic_word(dev, AtimWnd, 2);	

	PlatformIOWrite2Byte(dev, FEMR, 0xFFFF);

	write_nic_byte(dev, WPA_CONFIG, 0);

	MacConfig_85BASIC(dev);

	PlatformIOWrite2Byte(dev, RFSW_CTRL, 0x569a);

	write_nic_byte(dev, CR9346, 0xc0);	
	tmpu8 = read_nic_byte(dev, CONFIG3);	
#ifdef CONFIG_RTL818X_S
	write_nic_byte(dev, CONFIG3, (tmpu8 |CONFIG3_PARM_En) );
#else
	write_nic_byte(dev, CONFIG3, (tmpu8 |CONFIG3_PARM_En | CONFIG3_CLKRUN_En) );
#endif
	write_nic_dword(dev, ANAPARAM2, ANAPARM2_ASIC_ON);
	write_nic_dword(dev, ANAPARAM, ANAPARM_ASIC_ON);
#ifdef CONFIG_RTL818X_S
	write_nic_word(dev, ANAPARAM3, 0x0010);
#else
      write_nic_byte(dev, ANAPARAM3, 0x00);
#endif
 
	write_nic_byte(dev, CONFIG3, tmpu8);
	write_nic_byte(dev, CR9346, 0x00);
	btCR9346 = read_nic_byte(dev, CR9346);
	write_nic_byte(dev, CR9346, (btCR9346|0xC0) );

	TmpU1b = read_nic_byte(dev, CONFIG5);
	TmpU1b = TmpU1b & ~BIT3;
	write_nic_byte(dev,CONFIG5, TmpU1b);

	btCR9346 &= ~(0xC0);
	write_nic_byte(dev, CR9346, btCR9346);

	if(!(priv->ieee80211->bHwRadioOff) && !(priv->ieee80211->bSwRadioOff)) {
	btPSR = read_nic_byte(dev, PSR);
	write_nic_byte(dev, PSR, (btPSR | BIT3));
	}
#ifdef LED
	if(!(priv->ieee80211->bHwRadioOff) && !(priv->ieee80211->bSwRadioOff))
		LedControl8185(dev,LED_CTL_POWER_ON); 
#endif
	write_nic_word(dev, RFPinsOutput, 0x0480);  
	SetOutputEnableOfRfPins(dev);
	write_nic_word(dev, RFPinsSelect, 0x2488);

	PhyConfig8185(dev);

	SupportedWirelessMode = GetSupportedWirelessMode8185(dev);
	if(	(ieee->mode != WIRELESS_MODE_B) && 
		(ieee->mode != WIRELESS_MODE_G) &&
		(ieee->mode != WIRELESS_MODE_A) &&
		(ieee->mode != WIRELESS_MODE_AUTO)) 
	{ 
		bInvalidWirelessMode = 1;
	}
	else
	{ 
		if( (ieee->mode != WIRELESS_MODE_AUTO) &&
			(ieee->mode & SupportedWirelessMode) == 0 )
		{
			bInvalidWirelessMode = 1;
		}
	}

	if(bInvalidWirelessMode || ieee->mode==WIRELESS_MODE_AUTO)
	{ 
		if((SupportedWirelessMode & WIRELESS_MODE_A))
		{
			InitWirelessMode = WIRELESS_MODE_A;
		}
		else if((SupportedWirelessMode & WIRELESS_MODE_G))
		{
			InitWirelessMode = WIRELESS_MODE_G;
		}
		else if((SupportedWirelessMode & WIRELESS_MODE_B))
		{
			InitWirelessMode = WIRELESS_MODE_B;
		}
		else
		{
			DMESGW("InitializeAdapter8185(): No valid wireless mode supported, SupportedWirelessMode(%x)!!!\n", 
				 SupportedWirelessMode);
			InitWirelessMode = WIRELESS_MODE_B;
		}

		if(bInvalidWirelessMode)
		{
			ieee->mode = (WIRELESS_MODE)InitWirelessMode;
		}
	}
	else
	{ 
		InitWirelessMode = ieee->mode; 
	}
#ifdef ENABLE_IPS 
	priv->eRFPowerState = eRfOff;
	priv->RfOffReason = 0; 
	{	
		MgntActSet_RF_State(dev, eRfOn, 0);
	}	
	if (priv->bInactivePs)
	{
		MgntActSet_RF_State(dev,eRfOff, RF_CHANGE_BY_IPS);

	}
#endif
#ifdef TODO
	if(Adapter->MgntInfo.RegRfOff == TRUE)
	{
		SetRFPowerState8185(Adapter, RF_OFF);
	}
	else
	{
		SetRFPowerState8185(Adapter, RF_ON);
	}
#endif


	ActSetWirelessMode8185(dev, (u8)(InitWirelessMode));


	rtl8185b_irq_enable(dev);

	netif_start_queue(dev);

 }


void rtl8185b_rx_enable(struct net_device *dev)
{
	u8 cmd;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
#if 0
	rxconf=read_nic_dword(dev,RX_CONF);
	rxconf = rxconf &~ MAC_FILTER_MASK;
	rxconf = rxconf | (1<<ACCEPT_MNG_FRAME_SHIFT);
	rxconf = rxconf | (1<<ACCEPT_DATA_FRAME_SHIFT);
	rxconf = rxconf | (1<<ACCEPT_BCAST_FRAME_SHIFT);
	rxconf = rxconf | (1<<ACCEPT_MCAST_FRAME_SHIFT);
	if (dev->flags & IFF_PROMISC) DMESG ("NIC in promisc mode");
	
	if(priv->ieee80211->iw_mode == IW_MODE_MONITOR || \
	   dev->flags & IFF_PROMISC){
		rxconf = rxconf | (1<<ACCEPT_ALLMAC_FRAME_SHIFT);
	}else{
		rxconf = rxconf | (1<<ACCEPT_NICMAC_FRAME_SHIFT);
		if(priv->card_8185 == 0)
			rxconf = rxconf | (1<<RX_CHECK_BSSID_SHIFT);
	}
	
	
	if(priv->ieee80211->iw_mode == IW_MODE_MONITOR){
		rxconf = rxconf | (1<<ACCEPT_CTL_FRAME_SHIFT);	
		rxconf = rxconf | (1<<ACCEPT_ICVERR_FRAME_SHIFT);
		rxconf = rxconf | (1<<ACCEPT_PWR_FRAME_SHIFT);
	}
	
	if( priv->crcmon == 1 && priv->ieee80211->iw_mode == IW_MODE_MONITOR)
		rxconf = rxconf | (1<<ACCEPT_CRCERR_FRAME_SHIFT);
	
		rxconf = rxconf &~ RX_FIFO_THRESHOLD_MASK;
		rxconf = rxconf | (RX_FIFO_THRESHOLD_NONE<<RX_FIFO_THRESHOLD_SHIFT);
	
	rxconf = rxconf | (1<<RX_AUTORESETPHY_SHIFT);
	rxconf = rxconf &~ MAX_RX_DMA_MASK;
	rxconf = rxconf | (MAX_RX_DMA_2048<<MAX_RX_DMA_SHIFT);
	
		rxconf = rxconf | RCR_ONLYERLPKT;
	
	rxconf = rxconf &~ RCR_CS_MASK;
	if(!priv->card_8185)	
		rxconf |= (priv->rcr_csense<<RCR_CS_SHIFT);
	write_nic_dword(dev, RX_CONF, rxconf);
#endif

	if (dev->flags & IFF_PROMISC) DMESG ("NIC in promisc mode");
	
	if(priv->ieee80211->iw_mode == IW_MODE_MONITOR || \
	   dev->flags & IFF_PROMISC){
	   	priv->ReceiveConfig = priv->ReceiveConfig & (~RCR_APM);
		priv->ReceiveConfig = priv->ReceiveConfig | RCR_AAP;
	}
	
	
	if(priv->ieee80211->iw_mode == IW_MODE_MONITOR){
		priv->ReceiveConfig = priv->ReceiveConfig | RCR_ACF | RCR_APWRMGT | RCR_AICV;	
	}
	
	if( priv->crcmon == 1 && priv->ieee80211->iw_mode == IW_MODE_MONITOR)
		priv->ReceiveConfig = priv->ReceiveConfig | RCR_ACRC32;
	
	write_nic_dword(dev, RCR, priv->ReceiveConfig);
	
	fix_rx_fifo(dev);
	
#ifdef DEBUG_RX
	DMESG("rxconf: %x %x",priv->ReceiveConfig ,read_nic_dword(dev,RCR));
#endif
	cmd=read_nic_byte(dev,CMD);
	write_nic_byte(dev,CMD,cmd | (1<<CMD_RX_ENABLE_SHIFT));

}

void rtl8185b_tx_enable(struct net_device *dev)
{
	u8 cmd;
	u8 byte;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);

#if 0
	txconf= read_nic_dword(dev,TX_CONF);
	if(priv->card_8185){
		
	
		byte = read_nic_byte(dev,CW_CONF);
		byte &= ~(1<<CW_CONF_PERPACKET_CW_SHIFT);
		byte &= ~(1<<CW_CONF_PERPACKET_RETRY_SHIFT);
		write_nic_byte(dev, CW_CONF, byte);
		
		tx_agc_ctl = read_nic_byte(dev, TX_AGC_CTL);
		tx_agc_ctl &= ~(1<<TX_AGC_CTL_PERPACKET_GAIN_SHIFT);
		tx_agc_ctl &= ~(1<<TX_AGC_CTL_PERPACKET_ANTSEL_SHIFT);
		tx_agc_ctl |=(1<<TX_AGC_CTL_FEEDBACK_ANT);
		write_nic_byte(dev, TX_AGC_CTL, tx_agc_ctl);
		write_nic_byte(dev, 0xec, 0x3f); 
	}

	if(priv->card_8185){
		
		txconf = txconf &~ (1<<TCR_PROBE_NOTIMESTAMP_SHIFT);
	
	}else{
	
		if(hwseqnum) 
			txconf= txconf &~ (1<<TX_CONF_HEADER_AUTOICREMENT_SHIFT);
		else 
			txconf= txconf | (1<<TX_CONF_HEADER_AUTOICREMENT_SHIFT);
	}
	
	txconf = txconf &~ TX_LOOPBACK_MASK;
	txconf = txconf | (TX_LOOPBACK_NONE <<TX_LOOPBACK_SHIFT);
	txconf = txconf &~ TCR_DPRETRY_MASK;
	txconf = txconf &~ TCR_RTSRETRY_MASK;
	txconf = txconf | (priv->retry_data<<TX_DPRETRY_SHIFT);
	txconf = txconf | (priv->retry_rts<<TX_RTSRETRY_SHIFT);
	txconf = txconf &~ (1<<TX_NOCRC_SHIFT);
	
	if(priv->card_8185){
		if(priv->hw_plcp_len)
			txconf = txconf &~ TCR_PLCP_LEN;
		else
			txconf = txconf | TCR_PLCP_LEN;
	}else{
		txconf = txconf &~ TCR_SAT;
	}
	txconf = txconf &~ TCR_MXDMA_MASK;
	txconf = txconf | (TCR_MXDMA_2048<<TCR_MXDMA_SHIFT);
	txconf = txconf | TCR_CWMIN;
	txconf = txconf | TCR_DISCW;
	
		txconf=txconf | (1<<TX_NOICV_SHIFT);
	
	write_nic_dword(dev,TX_CONF,txconf);
#endif

	write_nic_dword(dev, TCR, priv->TransmitConfig);
	byte = read_nic_byte(dev, MSR);
	byte |= MSR_LINK_ENEDCA;
	write_nic_byte(dev, MSR, byte);

	fix_tx_fifo(dev);
	
#ifdef DEBUG_TX
	DMESG("txconf: %x %x",priv->TransmitConfig,read_nic_dword(dev,TCR));
#endif
	
	cmd=read_nic_byte(dev,CMD);
	write_nic_byte(dev,CMD,cmd | (1<<CMD_TX_ENABLE_SHIFT));		


}


#endif
